#include<bits/stdc++.h>
#define ll long long
using namespace std;


ll xord(ll x)
{
    vector<ll> del;
    ll res=1;
    for(int i=2;i<=sqrt(x);i++)
    {
        if(x%i==0)
        {
            res= res^i;
            del.push_back(i);
            
        }
    }
    for(int i=0;i<del.size();i++)
    {
        
        res=res^(x/del[i]);
    }
    return res;

}

int main()
{
    ll n,k;
    vector<int> d;
    cin>>n;
    cin>>k;
    for(int i=0;i<k;i++)
    {
        int l;
        cin>>l;
        d.push_back(l);
    }
    for(int i=0;i<k;i++)
    {

        cout<<xord(d[i])<<" ";
    }


}